"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/postgres.ts
var postgres_exports = {};
__export(postgres_exports, {
  createPostgresPool: () => createPostgresPool
});
module.exports = __toCommonJS(postgres_exports);
var import_runtime = require("@settlemint/sdk-utils/runtime");
var import_pg = __toESM(require("pg"), 1);
var sleep = (ms) => new Promise((resolve) => setTimeout(resolve, ms));
function setupErrorHandling(pool) {
  let retryCount = 0;
  pool.on("error", async (err) => {
    console.error("[Drizzle] Pool error occurred:", err);
    if (retryCount < 3) {
      retryCount++;
      console.log(`[Drizzle] Attempting to recover - retry ${retryCount}/3`);
      try {
        const client = await pool.connect();
        client.release();
        console.log("[Drizzle] Successfully recovered connection");
        retryCount = 0;
      } catch (retryError) {
        console.error(`[Drizzle] Recovery attempt ${retryCount} failed:`, retryError);
        await sleep(5e3 * 2 ** (retryCount - 1));
      }
    } else {
      console.error("[Drizzle] Max retries exceeded - pool is in an error state");
      pool.emit("permanent-failure", err);
    }
  });
  pool.on("connect", (client) => {
    client.on("error", (err) => {
      console.error("[Drizzle] Database client error:", err);
    });
  });
  pool.on("connect", () => {
    retryCount = 0;
  });
}
function createPostgresPool(databaseUrl) {
  if (!import_runtime.runsOnServer) {
    throw new Error("Drizzle client can only be created on the server side");
  }
  const pool = new import_pg.default.Pool({
    connectionString: databaseUrl,
    max: 20,
    idleTimeoutMillis: 3e4,
    connectionTimeoutMillis: 5e3
  });
  setupErrorHandling(pool);
  return pool;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createPostgresPool
});
//# sourceMappingURL=postgres.cjs.map